TimeAxisFactory = function (options, $dom) {
    this.options = options;
    this.$dom = $dom;
    this.chartID = options.chartID;
    this.autoRefreshTime = options.autoRefreshTime || 0;
    this.width = options.width || $dom.width();
    this.height = options.height || $dom.height();
    this.sheetIndex = options.sheetIndex || 0;
    this.ecName = options.ecName || '';
    this.firstQuery = true;
    this.canRefashTimeline = true;
    FR.Chart.WebUtils._installChart(this, this.chartID);
};

TimeAxisFactory.prototype = {
    constructor: TimeAxisFactory,
    inits: function () {
        var timelineParent, timelineBody;
        timelineParent = $(this.$dom[0]).find(".timeAxisParentDiv");
        if (timelineParent.length > 0) {
            $(timelineParent).remove();
        }

        //后台传过来的数据或者样式都在 this.options.chartAttr中
        //$(this.$dom[0]).css({"height":3000,"width":$(document).width(),"overflow":"auto !important"});
        var ct = this.options.chartAttr;
        //链接
        var minHeight = 100;
        if($(this.$dom[0]).height()!=null){
            minHeight = $(this.$dom[0]).height();
        }
        var chartID = this.options.chartID;
        var parentDiv = "<div style='overflow:auto;min-height:"+minHeight+"px;min-width:300px;width:100%;height:100%;background-color: #e9f0f5;' class='timeAxisParentDiv'></div>";
        if ($("#link" + chartID).length > 0) {
            $("#link" + chartID).remove();
        }
        if (typeof(ct.link) != "undefined") {
            var link = JSON.stringify(ct.link);timeAxisDiv
            if (link.length > 0) {//如果有超链接
                var timeid = $('<div id="link' + chartID + '" style="position:absolute;z-index:999' + 'left:0px;' + 'top:0px;"></div>').appendTo($(this.$dom[0]));
                var span = $('<span class="link' + chartID + ' linkSpan"></span>').appendTo(timeid);
                span.css("cursor", "pointer");
                span.attr('onclick', 'FR.doHyperlink(event||window.event,' + link + ',true)')
                timeid.css("width", this.width + "px");
                timeid.css("height", this.height + "px");
                span.append(parentDiv);
            } else {
                $(this.$dom[0]).append(parentDiv);
            }
        } else {
            $(this.$dom[0]).append(parentDiv);
        }

        timelineParent = $(this.$dom[0]).find(".timeAxisParentDiv");

        //节点样式
        var nodeData = {},nodeStyle = {};
        if(typeof(ct.nodeData)!="undefined"){
            nodeData = ct.nodeData;
        }
        var nodeStyleSetting = "false";
        if(typeof(ct.nodeStyleSetting)!="undefined"){
            nodeStyleSetting = ct.nodeStyleSetting;
        }
        nodeStyle = changeNodeSetting(nodeData,nodeStyleSetting);
        var resList = [];
        var icons = ["global", "agreement", "divisions", "speedometer", "customer", "network", "growth", "settings"]
        this.style = ct.themeData || {};
        this.data = ct.data || [];
        var datamap = ct.data;
        if(datamap){
            var i = 0;
            var strFullPath = window.document.location.href;
            var strPath = window.document.location.pathname;
            var pos = strFullPath.indexOf(strPath);
            var prePath = strFullPath.substring(0, pos);
            var postPath = strPath.substring(0, strPath.substr(1).indexOf('/') + 1);
            var fullUrl = prePath + postPath;
            for (var i; i < datamap.length; i++) {
                var tmp = {};
                tmp.year = datamap[i][0];
                tmp.title = datamap[i][1];
                tmp.content = datamap[i][2];
                tmp.addr = datamap[i][3];
                if (ct.useInternalIcon == 2 && datamap[i][4] != "") {
                    tmp.icon = datamap[i][4];
                } else if (ct.useInternalIcon == 3 && datamap[i][4] != "") {
                    tmp.icon = fullUrl + "/" + datamap[i][4].replace(/\\/g, "/");
                } else {
                    var selected_icon = icons[i % icons.length];
                    tmp.icon = "${servletURL}?op=resource&resource=/com/fr/plugin/timeaxischart/web/img/" + selected_icon + ".png";
                }
                resList.push(tmp);
            }
            var colors = [
                ["#66CCCC", "#FF99CC", "#99CC66", "#FF9999", "#666699", "#FF6600", "#0099CC", "#999999"],
                ["#336666", "#0099CC", "#999999", "#333366", "#99CCFF", "#336699", "#663366", "#6699CC"],
                ["#99CCCC", "#FFCCCC", "#CCCCFF", "#CCCCCC", "#66CCCC", "#FF9966", "#99CC99", "#FF6666"],
                ["#990066", "#333399", "#FFCC00", "#009999", "#663399", "#CCCC00", "#336699", "#FF6600"],
                ["#666699", "#CCFF66", "#003366", "#0099CC", "#336699", "#3399CC", "#CCCCCC", "#6699FF"],
                ["#CC9933", "#336666", "#CC99CC", "#990033", "#333366", "#FFCC99", "#666666", "#336633"],
                ["#993399", "#339999", "#FF6666", "#003399", "#99CC66", "#663366", "#CC6699", "#FFCC99"]
            ];
            var v = 1;
            var selected_color = 0;
            if (typeof(ct.themeData) != "undefined") {
                var theme = ct.themeData;
                if (theme.modeComboBox == "横向") {
                    v = 2;
                } else {
                    v = 1;
                }
                var themeComboBox = theme.themeComboBox;
                switch (themeComboBox) {
                    case "柔和明亮":
                        selected_color = 0;
                        break;
                    case "简单时尚":
                        selected_color = 1;
                        break;
                    case "清新简约":
                        selected_color = 2;
                        break;
                    case "华丽动感":
                        selected_color = 3;
                        break;
                    case "简洁进步":
                        selected_color = 4;
                        break;
                    case "忠厚稳重":
                        selected_color = 5;
                        break;
                    default:
                        selected_color = 6;
                }
            }
            var options = {
                "title": this.title,
                "resList": resList,
                "colors": colors[selected_color],
                "parentWidth": this.width,
                "parentHeight": this.height,
                "nodeStyle":nodeStyle
            };
            var chart;
            var titleVisible = true;
            this.title = "";
            if (v == 1) {
                //标题
                if (typeof(ct.titleData) != "undefined") {
                    titleVisible = ct.titleData.titleVisible;
                    if (titleVisible) {
                        var titleDivHtml = createTitleDiv(ct.titleData, 300);
                        this.title = ct.titleData.titleContent;
                        $(timelineParent).append(titleDivHtml);
                    }
                }
                $(timelineParent).append("<div style='min-height:"+minHeight+";min-width:300px;width:100%;height:100%;background-color: #e9f0f5;' class='timeAxisDiv'></div>");
                timelineBody = $(timelineParent).find(".timeAxisDiv");
                chart = new TimeAxisChart(options, $(timelineBody));
                chart.vInits();
            } else {
                if (typeof(ct.titleData) != "undefined") {
                    titleVisible = ct.titleData.titleVisible;
                    if (titleVisible) {
                        var titleDivHtml = createTitleDiv(ct.titleData, 300);
                        this.title = ct.titleData.titleContent;
                        $(timelineParent).append(titleDivHtml);
                    }
                }
                var titleTop = 20;
                if (this.height < 600) {
                    titleTop = 0;
                }
                $(timelineParent).append("<div style='margin-top:" + titleTop + "px;min-height:"+minHeight+"px;min-width:300px;background-color: #e9f0f5;' class='timeAxisDiv'></div>");
                timelineBody = $(timelineParent).find(".timeAxisDiv");
                chart = new TimeAxisChart(options, $(timelineBody));
                chart.hInits();
                dragLine($(timelineParent));
            }
        }else{
            if (typeof(ct.titleData) != "undefined") {
                titleVisible = ct.titleData.titleVisible;
                if (titleVisible) {
                    var titleDivHtml = createTitleDiv(ct.titleData, 300);
                    this.title = ct.titleData.titleContent;
                    $(timelineParent).append(titleDivHtml);
                    $(timelineParent).append("<div style='min-height:100px;min-width:100px;width:100%;height:100%;background-color: #e9f0f5;text-align:center;color:red' class='timeAxisDiv'>请先设置数据</div>");
                }
            }
        }


        this.canRefashTimeline = true;

        if (this.style.isUpdate == "true") {
            this.autoRefreshTime = this.style.updateTime;
            if (this.firstQuery) {
                this._autoRefresh(this.autoRefreshTime);
            }
        }
    },
    //自动刷新
    _autoRefresh: function (time) {
        if (time < 1) {
            return;
        }
        var self = this;
        setInterval(function () {
            var ID = FR.cjkEncode(self.chartID);
            var width = self.width || 0;
            var height = self.height || 0;
            var sheetIndex = self.sheetIndex;
            var ecName = self.ecName;
            if (FR.servletURL) {
                if (self.canRefashTimeline) {
                    self.canRefashTimeline = false;
                    FR.ajax({
                        type: 'GET',
                        url: FR.servletURL + '?op=chartauto',
                        data: {
                            cmd: 'chart_auto_refresh',
                            sessionID: FR.SessionMgr.getSessionID(),
                            chartID: ID,
                            chartWidth: width,
                            chartHeight: height,
                            sheetIndex: sheetIndex,
                            ecName: ecName,
                            __time: new Date().getTime()
                        },
                        dataType: 'json',
                        success: function (chartRelateJS) {
                            var attrList = chartRelateJS.relateChartList;
                            for (var i = 0, len = attrList.length; i < len; i++) {
                                var chartID = FR.Chart.WebUtils._getChartIDAndIndex(attrList[i].id);
                                var chartSet = FR.ChartManager[chartID[0]];
                                if (chartSet && chartSet[chartID[1]]) {
                                    var chartAttr = attrList[i].chartAttr;
                                    self._setAutoRefreshData(chartSet[chartID[1]], chartAttr);
                                }
                            }
                        }
                    });
                }

            }
        }, time * 1000);
    },
    _setAutoRefreshData: function (aa, bb) {
        this.options.chartAttr = bb;
        this.firstQuery = false;
        this.inits();
    },
    resize: function () {
        this.inits();
    },
    refresh: function () {

    },
    refreshData: function (options) {

    },

    //数据监控的刷新方式
    setData: function (options, aimation) {

    }
};

function dragLine(parent) {
    var about = $(parent).find(".about");
    if ($(about).length > 0) {
        var aboutWidth = $(about).width();
        //
        var processLine = $(about).find(".process-timeline");
        var processBody = $(processLine).find(".process-body");
        var draggableDiv = $(about).find(".draggableDiv");
        $(processLine).width(aboutWidth);
        var lastRightSpeed = 40; //控制拖动到最右边点是否对准时间刻度线上
        var processtimelineW = $(processLine).width();
        var processrowLength = $(processBody).find('.process-row').length;
        var processrowWidth = $(processBody).find('.process-row').width();
        var processbodyNumber = processrowLength * (processrowWidth + 20);
        $(processBody).css({"width": processbodyNumber});

        function left() {
            var processContent = $(about).find(".process-content");
            var processContentW = $(processContent).width();
            var processBodyW = $(processBody).width();
            var uiDraggable = $(about).find(".ui-draggable");
            var processBodyML = parseInt($(uiDraggable).css("left"));
            if ((Math.abs(processBodyML) + processtimelineW) >= processBodyW) {
                return;
            }
            $(uiDraggable).css({"left": processBodyML - 50});
        };

        function right() {
            var uiDraggable = $(about).find(".ui-draggable");
            var processBodyML = parseInt($(uiDraggable).css("left"));
            if (processBodyML == 0) {
                return;
            }
            $(uiDraggable).css({"left": processBodyML + 50});
        }

        /*
        $(document).keydown(function (event) {
            if (event.keyCode == 39) {
                left();
            }
            if (event.keyCode == 37) {
                right();
            }
        });
        */

        $(draggableDiv).draggable({
            cursor: "move",
            axis: 'x',
            grid: [50, 20],
            stop: function (event, ui) {
                var FleftNumber = parseInt($(draggableDiv).css("left"));
                if (FleftNumber > 0) {
                    $(draggableDiv).animate({"left": 0}, 500);
                    return;
                }
                var leftNumber = Math.abs(FleftNumber);
                leftNumber = leftNumber + processtimelineW;
                if (leftNumber > processbodyNumber) {
                    leftNumber = processbodyNumber;
                    $(draggableDiv).animate({"left": -(leftNumber - processtimelineW + lastRightSpeed)}, 500);
                }
            }
        });
    }
}

//生成标题
function createTitleDiv(titleData, minWidth) {
    var textCenter = 'left';
    var fontSize = 12;
    var fontFamily = '微软雅黑';
    var fontColor = '#333';
    var fontWeight = 100;
    var fontStyle = "normal";
    var borderRadius = 1;
    var borderColor = '#F05B72';
    var borderWeight = 0;
    var titleText = '新建图表标题';
    var titleBackgroundColor = 'rgba(200,200,200,0.6)';
    titleText = titleData.titleContent;
    fontSize = titleData.titleAttr.font.size;
    fontFamily = titleData.titleAttr.font.fontName;
    fontColor = titleData.titleAttr.font.color;
    borderColor = titleData.borderColor;
    var styleSetting = titleData.titleAttr.font.style;
    if (styleSetting != "") {
        var tmp = styleSetting.split(" ");
        if (tmp.indexOf("bold") != -1) {
            fontWeight = "bold";
        }
        if (tmp.indexOf("italic") != -1) {
            fontStyle = "italic";
        }
    }
    if (titleData.position == 0) {
        textCenter = 'center';
    }
    if (titleData.position == 4) {
        textCenter = 'right';
    }
    if (titleData.position == 2) {
        textCenter = 'left';
    }
    borderWeight = titleData.borderStyle;
    if (titleData.roundBorder) {
        borderRadius = titleData.roundRadius;
    }
    else {
        borderRadius = 0;
    }
    titleBackgroundColor = titleData.titleBackgroundColor;
    var titleDivHtml = "";
    titleDivHtml = [
        '<div style="margin-top:10px;margin-bottom:10px; height:35px;min-width:' + minWidth + 'px;width:100%;text-align: ' + textCenter + ';">',
        '<div style=" padding:5px 15px;line-height: 30px;display:inline;  height:30px;min-width: 100px; background: ' + titleBackgroundColor + '; text-align: center; color: ' + fontColor + '; font-family:' + fontFamily + ';font-size: ' + fontSize + 'px;font-weight:' + fontWeight + ';font-style:' + fontStyle + '; border: solid ' + borderWeight + 'px ' + borderColor + '; border-radius:' + borderRadius + 'px; ">' + titleText + '</div>',
        '</div>',
        '</div>'
    ];
    titleDivHtml = titleDivHtml.join('');
    return titleDivHtml;
}

function changeNodeSetting(node,nodeStyleSetting) {

    var nodeStyle = {};
    if(nodeStyleSetting=="false"){
        nodeStyle.titleStyle = "word-break:keep-all;white-space: nowrap;overflow: hidden;text-overflow: ellipsis;width: 100%";
        nodeStyle.timeStyle = "";
        nodeStyle.descStyle = "";
        return nodeStyle;
    }
    var fontFamily = "宋体", fontSize = 9, fontColor = "#000", fontStyle = "normal", fontWeight = "normal";
    var tmpStyle = "";
    //标题
    if (typeof(node.titlecolor) != "undefined") {
        fontColor = node.titlecolor;
    }
    if (typeof(node.titlefamily) != "undefined") {
        fontFamily = node.titlefamily;
    }
    if (typeof(node.titlesize) != "undefined") {
        fontSize = node.titlesize;
    }
    if (typeof(node.titlestyle) != "undefined") {
        //0-无；1-加粗；2-斜体；3-加粗+斜体；
        if (node.titlestyle == 1) {
            fontWeight = "bold";
        }
        if (node.titlestyle == 2) {
            fontStyle = "italic";
        }
        if (node.titlestyle == 3) {
            fontStyle = "italic";
            fontWeight = "bold";
        }
    }
    tmpStyle = 'color: ' + fontColor + '; font-family:' + fontFamily + ';font-size: ' + fontSize + 'px;font-weight:' + fontWeight + ';font-style:' + fontStyle;
    tmpStyle += ';word-break:keep-all;white-space: nowrap;overflow: hidden;text-overflow: ellipsis;width: 100%';
    nodeStyle.titleStyle = tmpStyle;

    //描述
    fontFamily = "宋体", fontSize = 9, fontColor = "#000", fontStyle = "normal", fontWeight = "normal";
    if (typeof(node.desccolor) != "undefined") {
        fontColor = node.desccolor;
    }
    if (typeof(node.descfamily) != "undefined") {
        fontFamily = node.descfamily;
    }
    if (typeof(node.descsize) != "undefined") {
        fontSize = node.descsize;
    }
    if (typeof(node.descstyle) != "undefined") {
        //0-无；1-加粗；2-斜体；3-加粗+斜体；
        if (node.descstyle == 1) {
            fontWeight = "bold";
        }
        if (node.descstyle == 2) {
            fontStyle = "italic";
        }
        if (node.descstyle == 3) {
            fontStyle = "italic";
            fontWeight = "bold";
        }
    }
    tmpStyle = 'color: ' + fontColor + '; font-family:' + fontFamily + ';font-size: ' + fontSize + 'px;font-weight:' + fontWeight + ';font-style:' + fontStyle;
    nodeStyle.descStyle = tmpStyle;

    //时间
    fontFamily = "宋体", fontSize = 9, fontColor = "#000", fontStyle = "normal", fontWeight = "normal";
    if (typeof(node.timecolor) != "undefined") {
        fontColor = node.timecolor;
    }
    if (typeof(node.timefamily) != "undefined") {
        fontFamily = node.timefamily;
    }
    if (typeof(node.timesize) != "undefined") {
        fontSize = node.timesize;
    }
    if (typeof(node.timestyle) != "undefined") {
        //0-无；1-加粗；2-斜体；3-加粗+斜体；
        if (node.timestyle == 1) {
            fontWeight = "bold";
        }
        if (node.timestyle == 2) {
            fontStyle = "italic";
        }
        if (node.timestyle == 3) {
            fontStyle = "italic";
            fontWeight = "bold";
        }
    }
    tmpStyle = 'color: ' + fontColor + '; font-family:' + fontFamily + ';font-size: ' + fontSize + 'px;font-weight:' + fontWeight + ';font-style:' + fontStyle;
    nodeStyle.timeStyle = tmpStyle;
    return nodeStyle;

}

!(function () {
    // provider
    try {
        var provider = BI.Providers.getProvider("report.controller.provider");
    } catch (e) {
        return;
    }
    var ImplClass = provider.getImpl();
    var Widget = BI.inherit(ImplClass, {
        mounted: function () {
            this.widget = FR.createWidget(BI.extend({}, this.options, {
                type: 'rh.iframe',
                renderEl: this.element[0]
            }));
            this.resize(this.options.width, this.options.height);
        },

        getValue: function () {
            return (this.widget && this.widget.getValue.apply(this.widget, arguments));
        },

        resize: function (width, height) {
            this.widget && this.widget.doResize({
                width: width, height: height
            });
        },

        refresh: function () {
            this.widget && this.widget.refresh.apply(this.widget, arguments)
        },
        reload: function () {
        }
    });

    Widget.xtype = "report.rh.iframe";
    BI.shortcut(Widget.xtype, Widget);
    provider.set('rh.iframe', Widget.xtype);

})();
