TimeAxisChart = function(options, dom) {
    this.options = options;
    this.dom = dom;
    this.outHtml = '';
    this.title = options.title || "";
    this.parentWidth = options.parentWidth || "";
    this.parentHeight = options.parentHeight||"";
    this.resList = options.resList || [];
    this.colors = options.colors || [];
    this.nodeStyle = options.nodeStyle;
};
TimeAxisChart.prototype = {
    constructor: TimeAxisChart,
    hInits: function() {
        //水平
        var html_str = '';
        html_str += '<div class="row">';
        html_str += '<div class="col-md-12 about">';
        html_str += '<div class="about-body">';
        html_str += '<div class="about-content process-content">';
        html_str += '<div class="process-timeline draggable ui-widget-content">';
        html_str += '<div class="draggableDiv">';
        html_str += '<div class="process-body">';
        var contentLength = 150;
        var titleLength = 22;
        var wideClass = "";
        if(this.parentHeight<600||this.parentWidth<600){
            contentLength = 10;
            titleLength = 8;
        }else{
            wideClass = "process-row1";
        }
        var res_length = this.resList.length;
        var colors_length = this.colors.length;
        for (var i = 0; i < res_length; i++) {
            var selected_color = this.colors[i % colors_length];
            html_str += '<div class="'+wideClass+' process-row ">';
            html_str += '<div class="process-time">';
            html_str += '<div class="time-con">';
            var year = cutString(this.resList[i].year, 40,false);
            html_str += '<span class="year" style="'+this.nodeStyle.timeStyle+'">' + year + '</span>';
            html_str += '<div class="timeline-icon" style="background-color:'+selected_color+'"><img src="' + this.resList[i].icon + '" alt="' + this.resList[i].year + '"></div>';
            html_str += '</div>';
            html_str += '</div>';
            html_str += '<div class="process-content">';
            var title = this.resList[i].title;//cutString(this.resList[i].title, titleLength,false);
            var content = cutString(this.resList[i].content, contentLength,true);
            html_str += '<h2 title="'+this.resList[i].title+'"style="'+this.nodeStyle.titleStyle+'">' + title + '</h2>';
            html_str += '<p title="'+this.resList[i].content+'" style="'+this.nodeStyle.descStyle+'">' + content + '</p>';
            if(this.resList[i].addr!=""){
                html_str += '<a href="' + this.resList[i].addr + '" class="cd-read-more" target="_blank">更多</a>';
            }
            html_str += '</div>';
            html_str += '</div>';
        }
        html_str += "</div></div></div></div></div></div></div>";
        this.outHtml = html_str;
        $(this.dom).html(html_str);
        
    },
    vInits: function() {
        //垂直
        var html_str = "";
        var wideClass="",wideClassBlock="",wideClassBlock1="",wideClassImg="",wideClassContent="";
        if(this.parentWidth>1000){
            wideClass = "cd-timeline1";
            wideClassBlock = "cd-timeline-block1";
            wideClassImg = "cd-timeline-img1";
            wideClassContent = "cd-timeline-content1";
        }
        html_str += '<div class="cd-timeline cd-container '+wideClass+'">';
        var res_length = this.resList.length;
        var colors_length = this.colors.length;
        var contentLength = 200;
        var titleLength = 30;
        if(this.parentWidth<500){
            contentLength = 28;
            titleLength = 18;
            wideClassBlock1 = "cd-timeline-block2";
        }else if(this.parentWidth<1000){
            contentLength = 74;
            titleLength = 30;
            wideClassBlock1 = "cd-timeline-block2";
        }
        for (var i = 0; i < res_length; i++) {
            var selected_color = this.colors[i % colors_length];
            html_str += '<div class="'+wideClassBlock+' cd-timeline-block '+wideClassBlock1+'" >';
            html_str += '<div class="'+wideClassImg+' cd-timeline-img " style="background-color:' + selected_color + '">';
            html_str += '<img src="' + this.resList[i].icon + '" alt="' + this.resList[i].year + '">';
            html_str += '</div>';
            html_str += '<div class="'+wideClassContent+' cd-timeline-content">';
            var title = this.resList[i].title;//cutString(this.resList[i].title, titleLength,false);
            var content = cutString(this.resList[i].content, contentLength,true);
            html_str += '<h2 title="'+this.resList[i].title+'" style="'+this.nodeStyle.titleStyle+'">' + title + '</h2>';

            if(this.parentWidth<1000){
                if(this.nodeStyle.descStyle==""){
                    this.nodeStyle.descStyle = "word-break:keep-all;white-space: nowrap;overflow: hidden;text-overflow: ellipsis;width: 100%";
                }
                html_str += '<p title="'+this.resList[i].content+ '" style="'+this.nodeStyle.descStyle+'">' + this.resList[i].content + '</p>';
            }else{
                html_str += '<p title="'+this.resList[i].content+ '" style="'+this.nodeStyle.descStyle+'">' + content + '</p>';
            }
            if(this.resList[i].addr!="") {
                html_str += '<a href="' + this.resList[i].addr + '" class="cd-read-more" target="_blank">更多</a>';
            }
            var year = cutString(this.resList[i].year, 40,false);
            html_str += '<span class="cd-date" style="'+this.nodeStyle.timeStyle+'">' + year + '</span>';
            html_str += '</div>';
            html_str += '</div>';
        }
        html_str += "</div>";
        html_str += "</div>";
        this.outHtml = html_str;
        $(this.dom).html(html_str);
        var height=0;
        $.each($(".cd-timeline-block"),function(i,n){
            height += $(n).height()+30;
        });
        if(this.title!=""){
            height +=160;
        }else{
            height +=85;
        }
        $(this.dom).css({"height":(height),"scroll":"auto"});
    },
    refresh: function() {}
};

function cutString(str, len,flag) {

    var str_length = getByteLen(str);
    if (str_length <= len) {
        return str;
    }
    var strlen = 0;
    var s = "";
    var subfix = "";
    if(flag){
        subfix = "…";
    }
    var tmpLength = 0;
    for (var i = 0; i < str.length; i++) {
        s = s + str.charAt(i);
        if (str.charCodeAt(i) > 128) {
            strlen = strlen + 2;
            if (strlen >= len) {
                tmpLength = s.length - 1;
                if(!flag){
                    tmpLength = s.length;
                }
                return s.substring(0, tmpLength)+ subfix;
            }
        } else {
            strlen = strlen + 1;
            if (strlen >= len) {
                tmpLength = s.length - 2;
                if(!flag){
                    tmpLength = s.length;
                }
                return s.substring(0, tmpLength)+ subfix;
            }
        }
    }
    return s;
}
function getByteLen(val) {
    var len = 0;
    for (var i = 0; i < val.length; i++) {
        var a = val.charAt(i);
        if (a.match(/[^\x00-\xff]/ig) != null)
        {
            len += 2;
        }
        else
        {
            len += 1;
        }
    }
    return len;
}
